From cb36ef863f7061d2e8fe3b401e1ab469beaec8b5 Mon Sep 17 00:00:00 2001
From: Ilya Shpigor <shpigor@etersoft.ru>
Date: Tue, 19 May 2009 13:38:37 +0400
Subject: [PATCH] msi: Subscribe to SetProgress event on adding progress bar control to dialog (eterbug #2042)

---
 dlls/msi/dialog.c |   11 ++++++++++-
 1 files changed, 10 insertions(+), 1 deletions(-)

diff --git a/dlls/msi/dialog.c b/dlls/msi/dialog.c
index df79a37..495e033 100644
--- a/dlls/msi/dialog.c
+++ b/dlls/msi/dialog.c
@@ -135,6 +135,8 @@ static const WCHAR szMaskedEdit[] = { 'M','a','s','k','e','d','E','d','i','t',0
 static const WCHAR szPathEdit[] = { 'P','a','t','h','E','d','i','t',0 };
 static const WCHAR szProgressBar[] = {
      'P','r','o','g','r','e','s','s','B','a','r',0 };
+static const WCHAR szSetProgress[] = {
+    'S','e','t','P','r','o','g','r','e','s','s',0 };
 static const WCHAR szRadioButtonGroup[] = { 
     'R','a','d','i','o','B','u','t','t','o','n','G','r','o','u','p',0 };
 static const WCHAR szIcon[] = { 'I','c','o','n',0 };
@@ -1571,7 +1573,14 @@ end:
 
 static UINT msi_dialog_progress_bar( msi_dialog *dialog, MSIRECORD *rec )
 {
-    msi_dialog_add_control( dialog, rec, PROGRESS_CLASSW, WS_VISIBLE );
+    msi_control *control;
+
+    control = msi_dialog_add_control( dialog, rec, PROGRESS_CLASSW, WS_VISIBLE );
+    if( !control )
+        return ERROR_FUNCTION_FAILED;
+
+    ControlEvent_SubscribeToEvent( dialog->package, dialog,
+                                   szSetProgress, control->name, szProgress );
     return ERROR_SUCCESS;
 }
 
-- 
1.6.2.5

